<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"] ?: array()) + array("_0877a0b" . "48cf424a" . "0de57a45" . "3ce95e30" . "c" => base64_decode("aW50" . "OnVz" . "ZXJf" . "aWQ="), "_84718d828d2acc3c366f9" . "6b07e841f6a" => base64_decode("YWNsLnN" . "pbXBsZQ" . "=="), "_b06968b9268deaf3b380bd0fe" . "922b453" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3RfY29kZSBlcTpzdHI6Y2" . "9kZSBBTkQgdXNlcl9pZD1pbnQ6dWlk"), "_27de5a45db71bf24058" . "769b61b3975a3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6IG9iamVjdCBjb2RlIG5vdCBz" . "cGVjaWZpZWQ="), "_a7ed4d7408bb99b87a09d89" . "d4212d5de" => base64_decode("c2ltcGxl" . "X2FjbA=="), "_80fc2a45acd0150df87d1fb72" . "8940a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2Jq" . "ZWN0X2NvZGUgZXE6c3RyOmNvZGUgQU5EIHVzZXJfaWQ9aW50OnVp" . "ZA=="), "_dbbe14f567693a63" . "1f8a43b65af917ab" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCBmcm9tIGRhdG" . "FiYXNlOiBvYmplY3QgY29kZSBub3Qgc3Bl" . "Y2lmaWVk"), "_ef2948c87ef38aab9226e" . "41189b29ca7" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3RfY2" . "9kZSBlcTpzdHI6Y29kZQ=="), "_a8b22fedb27a11e07f5" . "bb9a7c73608ea" => base64_decode("c3RyKDEwMCk6b2JqZWN0X2Nv" . "ZGU="), "_3cda3f34ada928e4aa39d462" . "9c5504aa" => base64_decode("aW50On" . "JpZ2h0" . "cw=="), "_c95cbc3161" . "78c97697a40" . "3f4d9124106" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0cyBGUk9NI" . "HNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2NvZG" . "UgZXE6c3RyOmNvZGU="), "_938704c4c0169c38" . "04d4bd6aa9941a76" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6IG9iamVjdCBjb2RlIG5vdCBzcGVjaWZpZW" . "Q="));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_84718d828d2ac" . "c3c366f96b07e8" . "41f6a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_80fc2a45acd0150df87d1fb728940a6" . "0"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_a7ed4d7408bb99b87a09d89d4212d5" . "de"], [$GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_a8b22fedb27" . "a11e07f5bb9a" . "7c73608ea"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_0877a0b48cf424a0d" . "e57a453ce95e30c"] => $user_id, $GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_3cda3f34ada928e" . "4aa39d4629c5504a" . "a"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_b06968b9268deaf3" . "b380bd0fe922b453"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_938704c4c016" . "9c3804d4bd6aa" . "9941a76"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_c95cbc316178" . "c97697a403f4d" . "9124106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_27de5a45db71bf2" . "4058769b61b3975a" . "3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_dbbe14f5676" . "93a631f8a43b" . "65af917ab"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_ef2948c87ef38aab922" . "6e41189b29ca7"], $acl->GetObjectCode());
    }
}